#!/usr/bin/perl -TCS

# comment.cgi: Reads and display the contents of a file in a manner that allows internet browsers to understand it.
# Copyright (C) <2021>  <Jake Thoughts>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

# Author       : Jake Thoughts jake@jakes-mail.top
# Release Date : 2021 Feb 03
# Version      : 0.8
# TODO         : captcha implimentation.

use strict;
#use warnings;
use utf8;

local (our $buffer, our @pairs, our $pair, our $name, our $value, our %FORM);

$ENV{'REQUEST_METHOD'} =~ tr/a-z/A-Z/;
$buffer = $ENV{'QUERY_STRING'};

@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9] [a-fA-F0-9])/pack("C", hex($1))/eg;
   $FORM{$name} = $value;
}
my $blog		= $FORM{blog};
my $mode		= $FORM{mode};
#my $date		= Date->time2str("%C", time);
my $html_form	= './html/comment_form.html';	# Apache SSI seems to run comment.cgi in the directory it was called in (ie blog directory)

if ($blog =~ /^([-\w.]+)$/ ) { # prevents ../
	$blog = $1;
	unless (-e "../protected/comments/$blog.txt") { # makes sure comment file for the blog page actually exist. 
		die "comment.cgi could not access $blog.txt (does not exist)";	
	}
} else {
	$blog = "";
	die "comment.cgi !!!Variable blog did not match!!! $ENV{'REMOTE_ADDR'}";
}

sub create_guest_form{
	open(FH, "<", $html_form) or die "comment.cgi could not open $html_form";
		while(<FH>){
			if ($mode eq "guest") {
				s/FORM_ACTION_VAR/post.cgi/;
			} else {
				s/FORM_ACTION_VAR/..\/post.cgi/;
			}
			s/REPLACE_THIS_WITH_VARIABLE/$blog/; 
			print "$_";
		}
	close(FH);
}

if ($mode eq "guest") {
	print "Content-type:text/html\r\n\r\n";
	print "<br>";
	print "<div class='block'>";
	print "<h2>My guestbook!</h2>";
	print "<pre>";
} else {
	print "Content-type:text/html\r\n\r\n";
	print "<link href='../style.css' rel='stylesheet' type='text/css' media='all'>";
	print "<div style='margin-bottom:0px;' class='block'>";
	print "<h3>Other thoughts</h3>";
	print "<pre>";
}

open(FH, "<", "../protected/comments/$blog.txt") or die "comment.cgi could not open blog.txt";
while (<FH>) {
	$_ =~ s/%0D%0A/\n/g; $_ =~ s/%21/!/g; $_ =~ s/%3F/?/g;	$_ =~ s/%2C/,/g;	$_ =~ s/%24/\$/g;
	$_ =~ s/%23/#/g; $_ =~ s/%40/@/g;	$_ =~ s/%3C/&lt;/g; # <
	$_ =~ s/%3E/&gt;/g; # >
	$_ =~ s/%3D/=/g;	$_ =~ s/%2B/+/g;	$_ =~ s/%2F/\//g; $_ =~ s/%60/`/g; $_ =~ s/%7E/~/g; $_ =~ s/%3A/\:/g;
	$_ =~ s/%3B/\;/g; $_ =~ s/%22/&quot;/g; # "
	$_ =~ s/%27/&apos;/g; # '
	$_ =~ s/%5C/\\/g; $_ =~ s/%7C/\|/g; $_ =~ s/%5B/[/g; $_ =~ s/%5D/]/g; $_ =~ s/%7B/{/g; $_ =~ s/%7D/}/g;
	$_ =~ s/%28/(/g; $_ =~ s/%29/)/g;	$_ =~ s/%26/&amp;/g; # &
	$_ =~ s/%25/%/g; $_ =~ s/%5E/^/g; $_ =~ s/%C2%A9/©/g; $_ =~ s/%C2%AE/®/g; $_ =~ s/%E2%84%A2/™/g; $_ =~ s/%C2%B0/°/g; 
	$_ =~ s/%E2%88%9A/√/g; $_ =~ s/%CF%80/π/g; $_ =~ s/%C2%B6/¶/g; $_ =~ s/%E2%88%86/Δ/g; $_ =~ s/%E2%80%A2/•/g; $_ =~ s/%E2%84%85/℅/g; $_ =~ s/%C3%97/×/g;
	
	#iphone
	$_ =~ s/%E2%80%98/'/g; $_ =~ s/%E2%80%9C/"/g; $_ =~ s/%E2%80%9D/"/g; $_ =~ s/%E2%80%99/'/g;
	
	# euro
	$_ =~ s/%E2%82%AC/€/g; $_ =~ s/%C2%A3/£/g; $_ =~ s/%C2%A5/¥/g; $_ =~ s/%C2%BF/¿/g; $_ =~ s/%C2%A1/¡/g; $_ =~ s/%C2%A2/¢/g; $_ =~ s/%C3%B7/÷/g;
	
	# bad words :(
	$_ =~ s/nigger/homie/gi; $_ =~ s/nigga/homie/gi; $_ =~ s/fuck/freak/gi;
	$_ =~ s/dick/pp/gi; $_ =~ s/cock/pp/gi; $_ =~ s/penis/pp/gi; $_ =~ s/vagina/pp/gi; $_ =~ s/pussy/cat/gi; $_ =~ s/bitch/dog-in-heat/gi;
	$_ =~ s/cracker/white/gi; $_ =~ s/boob/breast/gi;	$_ =~ s/porn/videos/gi; $_ =~ s/retard/special/gi; $_ =~ s/sex/intercourse/gi;
	
	# styling
	$_ =~ s/:joy:/😀/gi; $_ =~ s/:alien:/👽/gi; $_ =~ s/:smirk:/😏/gi; $_ =~ s/:eyes:/👀/gi; $_ =~ s/:tear:/😢/gi; $_ =~ s/:cry:/😭/gi; $_ =~ s/:heart:/💙/gi; $_ =~ s/:ok:/👌/gi; $_ =~ s/:mad:/😠/gi; $_ =~ s/:burger:/🍔/gi;
	$_ =~ s/:gun:/<img src="img\/gun.png">/gi; $_ =~ s/:puke:/🤮/gi; 
	
	print "<div class=\'guest_log\'>$_</div>";
}
close(FH);

print "</pre>";

create_guest_form();

print "</div>";

1;
